C PROGRAM ATLAS.F - TABARE GALLARDO, JANUARY 2006
C gallardo@fisica.edu.uy
C CALCULATES AN ATLAS OF RESONANCE'S STRENGTHS
C ACTUALIZED VERSION 2018
C mean a modified in 2019
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION SE(10),SM(10)
      DIMENSION NPLA(100000),NPQ(100000),NP(100000),SEMI(100000)
      DIMENSION A2(100000),NCPLA(100000),NCPQ(100000),NCP(100000)
      CHARACTER*56 cabezal
      CHARACTER*37 cabezal2
      CHARACTER*93 cabezal3
      COMMON ISIMAX,IPASOSF
      cabezal=' pla  |p+q|:|p|     a(AU)     e     i     omega        '
      cabezal2='<R>                  SR = <R> - R_min'
      cabezal3=cabezal//cabezal2

      WRITE(*,*)'------------------------------------------------------'
      WRITE(*,*)'            ATLAS OF MEAN MOTIONS RESONANCES |p+q|:|p|'
      WRITE(*,*)'This program calculates the resonance''s strengths SR'
      WRITE(*,*)'in a given semimajor axis interval with all planets.'
      WRITE(*,*)'SR(e,i,w) = <R>-Rmin  (Gallardo 2006, Icarus 184, 29)'
      WRITE(*,*)'Tabare Gallardo                gallardo@fisica.edu.uy '
      WRITE(*,*)'version 2018/2019'
      WRITE(*,*)'------------------------------------------------------'



      WRITE(*,*)' '
C MAX ORDER
      WRITE(*,*)'max order q?'
      READ(*,*)IQF
C MAX DEGREE
      WRITE(*,*)'max degree |p|?'
      READ(*,*)IPF
C MAX |P+Q|
      WRITE(*,*)'max |p+q|?'
      READ(*,*)NLIMPQ
C LIMITS IN SEMIMAJOR AXIS
      WRITE(*,*)'interval to be analyzed: a_min,a_max? (ex: 3.1,3.3)'
      READ(*,*)A2MIN,A2MAX
C PLANETS TO CONSIDER
      WRITE(*,*)'indicate first and last planet to be considered'
      WRITE(*,*)'1 for Mercury ... 8 for Neptune (ex: 1,8)'
      READ(*,*)IFIRSTP,ILASTP
C ORBITAL ELEMENTS OF THE PARTICLE
      WRITE(*,*)'e,i,argper for the particle? (ex: 0.3,35,127)'
      READ(*,*)exc,ync,arg
C PRECISION IN CALCULATION OF SR
      ISIMAX=18
  22    WRITE(*,*)'low (1) or high (2) precision?'
      WRITE(*,*)'(low precision is 10 times faster...)'
      READ(*,*)ilh
      if(ilh.eq.1) IPASOSF=100
      if(ilh.eq.2) IPASOSF=1000
      if(ilh.lt.1.or.ilh.gt.2) goto 22
C MEAN SEMIMAJOR AXIS  2019
C computed in long numerical integrations (500.000 yrs)
      SE(1)=  0.387099D0
      SE(2)=  0.723330D0
      SE(3)=  1.000001D0
      SE(4)=  1.523680D0
      SE(5)=  5.20261D0
      SE(6)=  9.55494D0
      SE(7)= 19.2185D0
      SE(8)= 30.1104D0
C MASS TO BE USED IN CALCULATION OF MEAN MOTIONS
      SM(1)=1.66013679D-07
      SM(2)=2.44783833D-06
      SM(3)=3.04043264D-06
      SM(4)=3.22715144D-07
      SM(5)=9.54791938D-04
      SM(6)=2.85885980D-04
      SM(7)=4.36624404D-05
      SM(8)=5.15138902D-05
C MASS OF THE SUN=1
      XM0=1.0D0
C MASS OF THE PARTICLE =0
      XM2=0.0D0
      ZM2=XM0+XM2
C COUNTER I
      I=0
C FOR EACH PLANET.....
      DO 200 JPLA=IFIRSTP,ILASTP
      XM1=SM(JPLA)
      ZM1=XM0+XM1

      A1=SE(JPLA)
C FOR EACH ORDER...
      DO IQ=0,IQF
        Q=IQ*1.D0
C FOR EACH DEGREE FOR INTERIOR RESONANCES....
        DO IP=1,IPF
          P=IP*1.D0
C LIMIT |P+Q|
          isum=abs(iq+ip)
          if(isum.le.nlimpq) then
C CALCULATE SEMIMAJOR AXIS
          sem=((P/(P+Q))**2*ZM2/ZM1)**(1.D0/3.D0)*A1
            IF (sem.LE.A2MAX.AND.sem.GE.A2MIN)  THEN
              i=i+1
              NPLA(I)=JPLA
              NPQ(I)=INT(ABS(P+Q))
              NP(I)=INT(ABS(P))
              A2(I)=sem
            endif
          endif
        ENDDO
      ENDDO
C NOW THE SAME FOR EXTERIOR RESONANCES
      DO IQ=0,IQF
        Q=IQ*1.D0
        DO IP=IQ,IPF-1
          P=-(IP+1)*1.D0
C LIMIT |P+Q|
          isum=abs(iq-ip-1)
          if(isum.le.nlimpq) then
          sem=((P/(P+Q))**2*ZM2/ZM1)**(1.D0/3.D0)*A1
            IF (sem.LE.A2MAX.AND.sem.GE.A2MIN)  THEN
              I=I+1
              NPLA(I)=JPLA
              NPQ(I)=INT(ABS(P+Q))
              NP(I)=INT(ABS(P))
              A2(I)=sem
            endif
          endif
        ENDDO
      ENDDO
 200  CONTINUE
C NUMBER OF POSSIBLE (redundant) RESONANCES, MUST BE LESS THAN 100000
      IDAT=I

      if(idat.ge.100000) then
        write(*,*)'error: too much resonances'
        stop
      end if
C ELIMINATE REPEATED, EXAMPLE: 4:2 IS THE SAME AS 2:1
      DO I=1,IDAT
        DO J=I+1,IDAT
          IF(NPLA(J).EQ.NPLA(I)) THEN
            IF (A2(J).EQ.A2(I).AND.NPQ(J).GE.NPQ(I)) THEN
              A2(J)=0.D0
            ENDIF
          ENDIF
        ENDDO
      ENDDO
      NCONT=0
      DO I=1,IDAT
        IF (A2(I).NE.0.D0) THEN
C LIMIT |P+Q|
C          IF (NPQ(I).LE.NLIMPQ)  THEN
            NCONT=NCONT+1
            NCPQ(NCONT)=NPQ(I)
            NCP(NCONT)=NP(I)
            NCPLA(NCONT)=NPLA(I)
            SEMI(NCONT)=A2(I)
C          ENDIF
        ENDIF
      ENDDO
C RESONANCES REPEATED WERE ELIMINATED
      WRITE(*,*)'I WILL CALCULATE ',NCONT,' RESONANCES'
C OK. WE NEED TO CALCULATE THE STRENGTH OF NCONT RESONANCES
      OPEN(1,FILE='atlas.dat',STATUS='UNKNOWN',ACCESS='APPEND')
      WRITE(1,*)'I WILL CALCULATE ',NCONT,' RESONANCES'
      write(1,*) cabezal3
      DO I=1,NCONT
        VPQ=DFLOAT(NCPQ(I))
        VP=DFLOAT(NCP(I))
        CALL FUERZA(VPQ,VP,NCPLA(I),EXC,YNC,ARG,FME,FUE)
        WRITE(1,45) NCPLA(I),NCPQ(I),NCP(I),SEMI(I),EXC,YNC,ARG,FME,FUE
        WRITE(*,45) NCPLA(I),NCPQ(I),NCP(I),SEMI(I),EXC,YNC,ARG,FME,FUE
      ENDDO
      CLOSE(1)
 45   FORMAT(3I5,F12.5,3F7.2,2F25.20)
      STOP
      END
C --------------------------------------------------------------------
C CALCULATES THE STRENGTH OF R(sigma).
C PLANETS ASSUMED IN CIRCULAR AND ZERO INCLINATION ORBITS
C THIS SUBROUTINE IS A SLIGTH MODIFICATION OF RSIGMA.F
      SUBROUTINE FUERZA(NPQ,NP,INPLA,EXC,YNC,ARGPER,FME,FUE)
      IMPLICIT REAL*8 (A-H,J-Z)
      DIMENSION RP(400),SE(10),SM(10)
      COMMON ISIMAX,IPASOSF
      TWOPI = 8.0D0*DATAN(1.0D0)
      CERO  = 0.0D0
      UNO   = 1.0D0
      PI=TWOPI/2.D0
      G2R=PI/180.D0
      ERROR=1.D-12
C      KGAUS=0.01720209895D0
C      KG2=KGAUS**2
C MEAN SEMIMAJOR AXIS  2019
C computed in long numerical integrations (500.000 yrs)
      SE(1)=  0.387099D0
      SE(2)=  0.723330D0
      SE(3)=  1.000001D0
      SE(4)=  1.523680D0
      SE(5)=  5.20261D0
      SE(6)=  9.55494D0
      SE(7)= 19.2185D0
      SE(8)= 30.1104D0
C MASSES
      SM(1)=1.66013679D-07
      SM(2)=2.44783833D-06
      SM(3)=3.04043264D-06
      SM(4)=3.22715144D-07
      SM(5)=9.54791938D-04
      SM(6)=2.85885980D-04
      SM(7)=4.36624404D-05
      SM(8)=5.15138902D-05
C NPQ=|P+Q|
C NP=|P|
C ORDER q
      ORQ=DABS(NPQ-NP)
      MAXFAC=NPQ
      IF(NPQ.LE.NP) THEN
C IT IS AN EXTERIOR RESONANCE  OR TROJANS
        MAXFAC=NP
        NPQ=-NPQ
        NP=-NP
      ENDIF
C sigma is invariant to changes in aries then I take aries at the node
C so longnode(particle)=0
C The planet is in circular and i=0 orbit  then the longper is not defined
C so I take \omega=\Omega=0 for the planet
      LONOD=0.D0
      LOPER=argper
C THE PLANET IS 1
      A1=SE(INPLA)
      E1=0.D0
      J1G=0.D0
      L1G=0.D0
      P1G=0.D0
      J1=J1G*G2R
      L1=L1G*G2R
      P1=P1G*G2R
C PARTICLE IS 2
      A2=A1/((DABS(NPQ/NP))**2/(1.d0+sm(inpla)))**(1.D0/3.D0)
      E2=EXC
      J2GRA=YNC
      J2=J2GRA*G2R
      L2G=LONOD
      P2G=LOPER
      L2=L2G*G2R
      P2=P2G*G2R
C ISIMAX = NUMBER OF EVALUATIONS OF R(sigma) BETWEEN O AND 360
C FOR MORE PRECISION USE MORE POINTS:
C 18 IS ENOUGHT FOR A ROUGH ESTIMATION
C 180 IS EXAGGERATEDLY PRECISE
C      ISIMAX=18
C      ISIMAX=180
C IPASOS = STEPS OF THE NUMERICAL INTEGRATION
C FOR MORE PRECISTION USE MORE POINTS
C TAKE CARE!!!!:     THIS INTEGRATION *MUST* BE PRECISE
C RETROGRADE ORBITS MAY REQUIRE MORE STEPS
      IPASOS=IPASOSF*INT(MAXFAC)
C sigma = (p+q)*lambda_p - p*lambda - q*varpi
      DO ISI=1,ISIMAX
C acrit is sigma
        ACRIT=DFLOAT(ISI-1)/DFLOAT(ISIMAX)*360.D0
        TETA=ACRIT+ORQ*LOPER
 901    IF (TETA.GT.360.D0) THEN
          TETA=TETA-360.D0
          GOTO 901
        END IF
C to radians
        TETAR=TETA*G2R
        RTOT=CERO
        DO ILAMBDA1=1,IPASOS
C all possible configurations occur after p revolutions of the planet
C LAMBDA PLANET
        LA1=DFLOAT(ILAMBDA1)/DFLOAT(IPASOS)*TWOPI*DABS(NP)
C MEAN ANOMALY
        AM1=LA1-P1
 200    IF (AM1.GT.TWOPI) THEN
          AM1=AM1-TWOPI
          GOTO 200
        END IF
 201    IF (AM1.LT.CERO) THEN
          AM1=AM1+TWOPI
          GOTO 201
        END IF
C GIVEN LAMBDA PLANET CALCULATE LAMBDA PARTICLE
        LA2=(NPQ*LA1-TETAR)/NP
C MEAN ANOMALY PARTICLE
        AM2=LA2-P2
 202    IF (AM2.GT.TWOPI) THEN
          AM2=AM2-TWOPI
          GOTO 202
        END IF
 203    IF (AM2.LT.CERO) THEN
          AM2=AM2+TWOPI
          GOTO 203
        END IF
C CRUDE METHOD FOR SOLVING KEPLER FOR PLANET
C JUST IN CASE YOU WANTED TO PUT SOME PLANETARY ECCENTRICITY
        AEX=AM1
 210    AEXN=AM1+E1*DSIN(AEX)
        IF(DABS(AEXN-AEX).GT.ERROR) THEN
          AEX=AEXN
          GOTO 210
        ENDIF
        AEX1=AEXN
C TRUE ANOMALY
        AVE1=DACOS((DCOS(AEX1)-E1)/(UNO-E1*DCOS(AEX1)))
        IF(AM1.GT.PI) AVE1=TWOPI-AVE1
C HELIOCENTRIC DISTANCE
        R1=A1*(UNO-E1*DCOS(AEX1))
C CRUDE METHOD FOR SOLVING KEPLER FOR PARTICLE (ECCENTRIC)
C        AEX=AM2
C 211    AEXN=AM2+E2*DSIN(AEX)
C        IF(DABS(AEXN-AEX).GT.ERROR) THEN
C          AEX=AEXN
C          GOTO 211
C        ENDIF
C        AEX2=AEXN
C SOLVING KEPLER FOR PARTICLE BY CLEVER METHOD
      CALL SOLKEP(E2,AM2,AEX2,INITER)
C TRUE ANOMALY
        AVE2=DACOS((DCOS(AEX2)-E2)/(UNO-E2*DCOS(AEX2)))
        IF(AM2.GT.PI) AVE2=TWOPI-AVE2
C HELIOCENTRIC DISTANCE
        R2=A2*(UNO-E2*DCOS(AEX2))
C RADIUS VECTOR FOR PLANET
        X1=R1*(DCOS(L1)*DCOS(P1-L1+AVE1)-DSIN(L1)*DSIN(P1-L1+AVE1)
     **DCOS(J1))
        Y1=R1*(DSIN(L1)*DCOS(P1-L1+AVE1)+DCOS(L1)*DSIN(P1-L1+AVE1)
     **DCOS(J1))
        Z1=R1*DSIN(P1-L1+AVE1)*DSIN(J1)
C RADIUS VECTOR FOR PARTICLE
        X2=R2*(DCOS(L2)*DCOS(P2-L2+AVE2)-DSIN(L2)*DSIN(P2-L2+AVE2)
     **DCOS(J2))
        Y2=R2*(DSIN(L2)*DCOS(P2-L2+AVE2)+DCOS(L2)*DSIN(P2-L2+AVE2)
     **DCOS(J2))
        Z2=R2*DSIN(P2-L2+AVE2)*DSIN(J2)
C DISTANCE
        DELTA=DSQRT((X1-X2)**2+(Y1-Y2)**2+(Z1-Z2)**2)
C SCALAR PRODUCT R1*R2
        R1R2=X1*X2+Y1*Y2+Z1*Z2
C DIRECT PART
        RDIR=UNO/DELTA
C INDIRECT PART (PROBABLY THIS IS A WASTE OF TIME)
        RIND=-R1R2/R1**3
C DISTURBING FUNCTION
        RPER=RDIR+RIND
C SUMATION FOR A CRUDE INTEGRAL
        RTOT=RTOT+RPER
        ENDDO
C END OF LOOP FOR LAMBDA
      RTOT=RTOT/DFLOAT(IPASOS)
C NOW MULTIPLY BY MASS_PLANET/MASS_JUPITER
      RP(ISI)=RTOT*SM(INPLA)/SM(5)
C TO OBTAIN STANDARD UNITS MULTIPLY RP BY MASS_JUPITER*KGAUSS**2
      ENDDO
C END OF LOOP FOR SIGMA
C CALCULATION OF MEAN VALUE <R>
      VMEDIO=0.D0
      DO I2=1,ISIMAX
        VMEDIO=VMEDIO+RP(I2)
      ENDDO
      VMEDIO=VMEDIO/DFLOAT(ISIMAX)
C FIND R_max AND R_min
      VRMAX=-999999.D0
      VRMIN=999999.D0
      DO I2=1,ISIMAX
        IF(RP(I2).LT.VRMIN) THEN
          VRMIN=RP(I2)
        ENDIF
        IF(RP(I2).GT.VRMAX) THEN
          VRMAX=RP(I2)
        ENDIF
      ENDDO
      FME=VMEDIO
      FUE=VMEDIO-VRMIN
      RETURN
      END
C ========================================================================
C SOLVING KEPLER
      SUBROUTINE SOLKEP(EX,M,E,NITER)
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 M,MK
      TOLE=1.D-12
      TWOPI=8.D0*DATAN(1.D0)
      M=DMOD(M,TWOPI)
      E=M
      NITER=0
 100  E0=E
      SE=DSIN(E0)
      CE=DCOS(E0)
      ES=EX*SE
      EC=1.D0-EX*CE
      MK=E0-ES
      U=(MK-M)/EC
      XPRI=E0-U
      XSEG=E0-U/(1.D0-U*ES)
      E=(XPRI+XSEG)/2.D0
      DEX=DABS(E-E0)
      NITER=NITER+1
C	 IF(NITER.GT.20)GOTO 200
      IF(DEX.GT.TOLE)GOTO 100
      RETURN
      END
C ========================================================================

